const express = require("express");
const router = express.Router();
const {
  getUsersForSidebar,
  getMessages,
  sendMessage,
  getLastMessages,
  seenMessage,
  updateMessage,
  deleteMessage,
  typingStatus,
} = require("../controllers/messageController");
const messageController = require("../controllers/messageController");
const { protect } = require("../controllers/authController"); // Middleware for authentication

// Route to fetch users for the sidebar (excluding the logged-in user)
// router.get("/users", protect, getUsersForSidebar);
router.get("/conversations", protect, messageController.getMessagedUsers);
router.get("/users", protect, getUsersForSidebar);
router.get("/:id", protect, getMessages);
// Route to mark a message as seen
router.post("/seen", protect, seenMessage);

// Route to update a message
router.post("/update", protect, updateMessage);

// Route to delete a message
router.post("/delete", protect, deleteMessage);

router.post("/send/:id", protect, sendMessage);
// Route to handle typing status
router.post("/typing", protect, typingStatus);

// Route to fetch chat messages between the logged-in user and a specific user
// router.get("/:id", protect, getMessages);
router.get("/last/:id", protect, getLastMessages);

// Route to send a message to a specific user
// router.post("/send/:id", protect, sendMessage);

module.exports = router;
