const express = require("express");
const router = express.Router();
const notificationController = require("../controllers/notificationController");
const { protect } = require("../controllers/authController");

router.use(protect);

// Get notifications
router.get("/", notificationController.getNotifications);

// Mark notification as read
router.post("/:notificationId/read", notificationController.markAsRead);

router.post("/mark-all-read", notificationController.markAllAsRead);

router.delete("/delete-all", notificationController.softDeleteAllNotifications); 
// Soft delete notification
router.delete("/:notificationId", notificationController.softDeleteNotification);
module.exports = router;
