const admin = require("./firebaseServices");

const sendPushNotification = async (token, title, body, senderId, receiverId) => {
  const message = {
    notification: {
      title,
      body,
    },
    data: {
      senderId: senderId.toString(), // Convert to string (FCM requires string values)
      receiverId: receiverId.toString(),
      click_action: "FLUTTER_NOTIFICATION_CLICK", // Ensures app handles click event
    },
    token, // FCM Token of the recipient
  };

  try {
    await admin.messaging().send(message);
    console.log(`📨 Push notification sent successfully! [Sender: ${senderId}, Receiver: ${receiverId}]`);
  } catch (error) {
    console.error("❌ Error sending push notification:", error);
  }
};

module.exports = sendPushNotification;
